Search events
Search
The /v4/events endpoint provides a convenient way to search for past events based on specific parameters. Typical use cases and queries include:
- Searching for events associated with a single
visitor_idwithin a time range to get historical behavior of a visitor. - Searching for events associated with a single
linked_idwithin a time range to get all events associated with your internal account identifier. - Excluding all bot traffic from the query (
goodandbadbots)
By default, the API searches events from the last 7 days, sorts them by newest first and returns the last 10 events.
- Use
startandendto specify the time range of the search. - Use
reverse=trueto sort the results oldest first. - Use
limitto specify the number of events to return. - Use
pagination_keyto get the next page of results if there are more thanlimitevents.
Filtering events with the suspect flag
The /v4/events endpoint unlocks a powerful method for fraud protection analytics. The suspect flag is exposed in all events where it was previously set by the update API.
You can also apply the suspect query parameter as a filter to find all potentially fraudulent activity that you previously marked as suspect. This helps identify patterns of fraudulent behavior.
Environment scoping
If you use a secret key that is scoped to an environment, you will only get events associated with the same environment. With a workspace-scoped environment, you will get events from all environments.
Smart Signals not activated for your workspace or are not included in the response.
Documentation Index
Fetch the complete documentation index at: https://docs.fingerprint.com/llms.txt
Use this file to discover all available pages before exploring further.
Authorizations
Add your Secret API Key to the Authorization header using the standard Bearer format: Authorization: Bearer <secret_api_key>
Query Parameters
Maximum number of events to return. Results are selected from the time range (start, end), ordered by reverse, then truncated to provided limit size. So reverse=true returns the oldest N=limit events, otherwise the newest N=limit events.
1 <= x <= 10010
Use pagination_key to get the next page of results.
When more results are available (e.g., you requested up to 100 results for your query using limit, but there are more than 100 events total matching your request), the pagination_key field is added to the response. The pagination key is an arbitrary string that should not be interpreted in any way and should be passed as-is. In the following request, use that value in the pagination_key parameter to get the next page of results:
- First request, returning most recent 100 events:
GET api-base-url/events?limit=100 - Use
response.pagination_keyto get the next page of results:GET api-base-url/events?limit=100&pagination_key=1740815825085
Unique visitor identifier issued by Fingerprint Identification and all active Smart Signals.
Filter events by matching Visitor ID (identification.visitor_id property).
The High Recall ID is a supplementary browser identifier designed for use cases that require wider coverage over precision. Compared to the standard visitor ID, the High Recall ID strives to match incoming browsers more generously (rather than precisely) with existing browsers and thus identifies fewer browsers as new. The High Recall ID is best suited for use cases that are sensitive to browsers being identified as new and where mismatched browsers are not detrimental.
Filter events by matching High Recall ID (supplementary_id_high_recall.visitor_id property).
Filter events by the Bot Detection result, specifically:
all - events where any kind of bot was detected.
good - events where a good bot was detected.
bad - events where a bad bot was detected.
none - events where no bot was detected.
Note: When using this parameter, only events with the
botproperty set to a valid value are returned. Events without abotSmart Signal result are left out of the response.
all, good, bad, none Filter events by their Bot Info result, specifically:
all- events where any kind of bot was detected.none- events where no bot was detected.
all, none Filter events by their Bot Info Category.
Multiple categories can be provided using the repeated keys syntax. For example, bot_info_category=ai_agent&bot_info_category=ai_assistant, will match events with a Bot Info Category of ai_agent or ai_assistant. Other notations like comma-separated or bracket notation are not supported.
The type and purpose of the bot.
advertising_and_marketing, aggregator, ai_agent, ai_assistant, ai_browser, ai_crawler, ai_search, browser_automation, ecommerce, monitoring_and_analytics, other, scraping, security, search_engine_crawler, search_engine_optimization, unknown Filter events by their Bot Info Identity type.
Multiple identity types can be provided using the repeated keys syntax. For example, bot_info_identity=verified&bot_info_identity=signed, will match events with a Bot Info Identity of verified or signed. Other notations like comma-separated or bracket notation are not supported.
The verification status of the bot's identity:
verified- well-known bot with publicly verifiable identity, directed by the bot provider.signed- bot that signs its platform via Web Bot Auth, directed by the bot provider's customers.spoofed- bot that claims a public identity but fails verification.unknown- bot that does not publish a verifiable identity.
verified, signed, spoofed, unknown Filter events by their Bot Info Confidence.
Multiple confidences can be provided using the repeated keys syntax. For example, bot_info_confidence=high&bot_info_confidence=medium, will match events with a Bot Info Confidence of high or medium. Other notations like comma-separated or bracket notation are not supported.
Confidence level of the bot identification.
low, medium, high Filter events by their Bot Info Provider. The provider must match exactly, partial or wildcard matching is not supported.
Multiple Providers can be provided using the repeated keys syntax. For example, bot_info_provider=OpenAI&bot_info_provider=AWS, will match events with a Bot Info Provider of OpenAI or AWS. Other notations like comma-separated or bracket notation are not supported.
Filter events by their Bot Info Name. The name must match exactly, partial or wildcard matching is not supported.
Multiple Names can be provided using the repeated keys syntax. For example, bot_info_name=ChatGPT%20Agent&bot_info_name=Bedrock%20AgentCore, will match events with a Bot Info Name of ChatGPT Agent or Bedrock AgentCore. Other notations like comma-separated or bracket notation are not supported.
Filter events by IP address or IP range (if CIDR notation is used). If CIDR notation is not used, a /32 for IPv4 or /128 for IPv6 is assumed. Examples of range based queries: 10.0.0.0/24, 192.168.0.1/32
Filter events by the ASN associated with the event's IP address.
This corresponds to the ip_info.(v4|v6).asn property in the response.
Filter events by your custom identifier.
You can use linked Ids to associate identification requests with your own identifier, for example, session Id, purchase Id, or transaction Id. You can then use this linked_id parameter to retrieve all events associated with your custom identifier.
Filter events by the URL (url property) associated with the event.
Filter events by the Bundle ID (iOS) associated with the event.
Filter events by the Package Name (Android) associated with the event.
Filter events by the origin field of the event. This is applicable to web events only (e.g., https://example.com)
Include events that happened after this point (with timestamp greater than or equal the provided start Unix milliseconds value or RFC3339 timestamp). Defaults to 7 days ago. Setting start does not change end's default of now — adjust it separately if needed.
1767225600000
Include events that happened before this point (with timestamp less than or equal the provided end Unix milliseconds value or RFC3339 timestamp). Defaults to now. Setting end does not change start's default of 7 days ago — adjust it separately if needed.
1769903999000
When true, sort events oldest first (ascending timestamp order). Defaults to false (newest first, descending timestamp order).
Filter events previously tagged as suspicious via the Update API.
Note: When using this parameter, only events with the
suspectproperty explicitly set totrueorfalseare returned. Events with undefinedsuspectproperty are left out of the response.
Filter events by VPN Detection result.
Note: When using this parameter, only events with the
vpnproperty set totrueorfalseare returned. Events without avpnSmart Signal result are left out of the response.
Filter events by Virtual Machine Detection result.
Note: When using this parameter, only events with the
virtual_machineproperty set totrueorfalseare returned. Events without avirtual_machineSmart Signal result are left out of the response.
Filter events by Browser Tampering Detection result.
Note: When using this parameter, only events with the
tampering.resultproperty set totrueorfalseare returned. Events without atamperingSmart Signal result are left out of the response.
Filter events by Anti-detect Browser Detection result.
Note: When using this parameter, only events with the
tampering.anti_detect_browserproperty set totrueorfalseare returned. Events without atamperingSmart Signal result are left out of the response.
Filter events by Browser Incognito Detection result.
Note: When using this parameter, only events with the
incognitoproperty set totrueorfalseare returned. Events without anincognitoSmart Signal result are left out of the response.
Filter events by Privacy Settings Detection result.
Note: When using this parameter, only events with the
privacy_settingsproperty set totrueorfalseare returned. Events without aprivacy_settingsSmart Signal result are left out of the response.
Filter events by Jailbroken Device Detection result.
Note: When using this parameter, only events with the
jailbrokenproperty set totrueorfalseare returned. Events without ajailbrokenSmart Signal result are left out of the response.
Filter events by Frida Detection result.
Note: When using this parameter, only events with the
fridaproperty set totrueorfalseare returned. Events without afridaSmart Signal result are left out of the response.
Filter events by Factory Reset Detection result.
Note: When using this parameter, only events with a
factory_resettime. Events without afactory_resetSmart Signal result are left out of the response.
Filter events by Cloned App Detection result.
Note: When using this parameter, only events with the
cloned_appproperty set totrueorfalseare returned. Events without acloned_appSmart Signal result are left out of the response.
Filter events by Android Emulator Detection result.
Note: When using this parameter, only events with the
emulatorproperty set totrueorfalseare returned. Events without anemulatorSmart Signal result are left out of the response.
Filter events by Rooted Device Detection result.
Note: When using this parameter, only events with the
root_appsproperty set totrueorfalseare returned. Events without aroot_appsSmart Signal result are left out of the response.
Filter events by VPN Detection result confidence level.
high - events with high VPN Detection confidence.
medium - events with medium VPN Detection confidence.
low - events with low VPN Detection confidence.
Note: When using this parameter, only events with the
vpn.confidenceproperty set to a valid value are returned. Events without avpnSmart Signal result are left out of the response.
high, medium, low Filter events with Suspect Score result above a provided minimum threshold.
Note: When using this parameter, only events where the
suspect_scoreproperty set to a value exceeding your threshold are returned. Events without asuspect_scoreSmart Signal result are left out of the response.
Filter events by Developer Tools detection result.
Note: When using this parameter, only events with the
developer_toolsproperty set totrueorfalseare returned. Events without adeveloper_toolsSmart Signal result are left out of the response.
Filter events by Location Spoofing detection result.
Note: When using this parameter, only events with the
location_spoofingproperty set totrueorfalseare returned. Events without alocation_spoofingSmart Signal result are left out of the response.
Filter events by MITM (Man-in-the-Middle) Attack detection result.
Note: When using this parameter, only events with the
mitm_attackproperty set totrueorfalseare returned. Events without amitm_attackSmart Signal result are left out of the response.
Filter events by Device Rarity detection result.
Note: When using this parameter, only events with the
rare_deviceproperty set totrueorfalseare returned. Events without a Device Rarity Smart Signal result are left out of the response.
This Smart Signal is currently in beta and only available to select customers. If you are interested, please contact our support team.
Filter events by Device Rarity percentile bucket.
<p95 - device configuration is in the bottom 95% (most common).
p95-p99 - device is in the 95th to 99th percentile.
p99-p99.5 - device is in the 99th to 99.5th percentile.
p99.5-p99.9 - device is in the 99.5th to 99.9th percentile.
p99.9+ - device is in the top 0.1% (rarest).
not_seen - device configuration has never been observed before.
This Smart Signal is currently in beta and only available to select customers. If you are interested, please contact our support team.
<p95, p95-p99, p99-p99.5, p99.5-p99.9, p99.9+, not_seen Filter events by Proxy detection result.
Note: When using this parameter, only events with the
proxyproperty set totrueorfalseare returned. Events without aproxySmart Signal result are left out of the response.
Filter events by a specific SDK version associated with the identification event (sdk.version property). Example: 3.11.14
Filter events by the SDK Platform associated with the identification event (sdk.platform property) .
js - Javascript agent (Web).
ios - Apple iOS based devices.
android - Android based devices.
js, android, ios Filter for events by providing one or more environment IDs (environment_id property).
Array syntax
To provide multiple environment IDs, use the repeated keys syntax (environment=env1&environment=env2).
Other notations like comma-separated (environment=env1,env2) or bracket notation (environment[]=env1&environment[]=env2) are not supported.
Filter events by the most precise Proximity ID provided by default.
Note: When using this parameter, only events with the
proximity.idproperty matching the provided ID are returned. Events without aproximityresult are left out of the response.
When set, the response will include a total_hits property with a count of total query matches across all pages, up to the specified limit.
1 <= x <= 1000Filter events by Tor Node detection result.
Note: When using this parameter, only events with the
tor_nodeproperty set totrueorfalseare returned. Events without ator_nodedetection result are left out of the response.
Filter events by their incremental identification status (incremental_identification_status property). Non incremental identification events are left out of the response.
partially_completed, completed Filter events by iOS Simulator Detection result.
Note: When using this parameter, only events with the
simulatorproperty set totrueorfalseare returned. Events without asimulatorSmart Signal result are left out of the response.
Response
Events matching the filter(s).
Contains a list of all identification events matching the specified search criteria.
Use this value in the pagination_key parameter to request the next page of search results.
This value represents the total number of events matching the search query, up to the limit provided in the total_hits query parameter. Only present if the total_hits query parameter was provided.